# OE: conditional switches
#(ie. use with rpm --rebuild):
#	--with diet	Compile cgiwrap against dietlibc

%define build_diet 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_diet: %{expand: %%define build_diet 1}}

Summary: 	User CGI access
Name: 		cgiwrap
Version: 	4.1
Release: 	%mkrel 2
License: 	GPL
Group: 		System/Servers
URL:		http://cgiwrap.unixtools.org/
Source0: 	http://prdownloads.sourceforge.net/cgiwrap/%{name}-%{version}.tar.gz
Source1: 	conf.tar.bz2
Source2: 	php-cgiwrap-docs.tar.bz2
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires:	php-cgi apache-mpm
%if %{build_diet}
BuildRequires:	dietlibc-devel >= 0.20-1mdk
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
This is CGIWrap - a gateway that allows more secure user access to
CGI programs on an HTTPd server than is provided by the http
server itself. The primary function of CGIwrap is to make certain
that any CGI script runs with the permissions of the user who
installed it, and not those of the server.

%prep

%setup -q -n %{name}-%{version} -a1 -a2

%build
#libtoolize --copy --force; aclocal; autoconf

%if %{build_diet}
# OE: use the power of dietlibc
export CFLAGS="-Os -pipe -D_BSD_SOURCE -D_GNU_SOURCE -static -nostdinc"
export CC="diet gcc $CFLAGS"
export GCC="diet gcc $CFLAGS"
%else
%serverbuild
%endif

%configure2_5x \
    --with-perl=%{_bindir}/perl \
    --with-local-doc-url=/cgiwrap \
    --with-install-dir=/var/www/cgi-bin \
    --with-cgi-dir="public_html/cgi-bin" \
    --with-httpd-user=apache \
    --with-minimum-uid=500 \
    --with-minimum-gid=100 \
    --without-redirect-stderr \
    --with-logging-file=/var/log/cgiwrap.log \
    --with-allow-file=%{_sysconfdir}/cgiwrap.allow \
    --with-deny-file=%{_sysconfdir}/cgiwrap.deny \
    --with-rewrite=%{_sysconfdir}/cgiwrap.userdir \
    --with-host-checking \
    --with-check-shell \
    --with-rlimit-core=0 \
    --with-rlimit-cpu=30 \
    --with-php=%{_bindir}/php-cgi \
    --with-php-cgiwrap \
    --with-php-interpreter

%make 

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}/var/www/cgi-bin
install -d %{buildroot}/var/www/html/cgiwrap
install -d %{buildroot}/var/log

install cgiwrap %{buildroot}/var/www/cgi-bin/
ln -s cgiwrap %{buildroot}/var/www/cgi-bin/cgiwrapd
ln -s cgiwrap %{buildroot}/var/www/cgi-bin/nph-cgiwrap
ln -s cgiwrap %{buildroot}/var/www/cgi-bin/nph-cgiwrapd
ln -s cgiwrap %{buildroot}/var/www/cgi-bin/php-cgiwrap
ln -s cgiwrap %{buildroot}/var/www/cgi-bin/php-cgiwrapd

install -m644 cgiwrap.allow %{buildroot}/%{_sysconfdir}/
install -m644 cgiwrap.deny %{buildroot}/%{_sysconfdir}/
install -m644 cgiwrap.userdir %{buildroot}/%{_sysconfdir}/
install -m644 htdocs/* %{buildroot}/var/www/html/cgiwrap/

# install the apache2 config
cat > %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/Z10_cgiwrap.conf << EOF

# The following was taken from the http://localhost/cgiwrap/php-cgiwrap.html file.

# for other use it as needed:
AddHandler cgi-wrapper .cgi
Action cgi-wrapper /cgi-bin/cgiwrap

# that is specially for php developers:
AddHandler php-cgiwrap .php
AddHandler php-cgiwrap .php3
AddHandler php-cgiwrap .phtml
Action php-cgiwrap /cgi-bin/php-cgiwrap
Action php-cgiwrapd /cgi-bin/php-cgiwrapd

EOF

# fix ghost log file
touch %{buildroot}/var/log/cgiwrap.log

# fix logrotate file
cat > %{buildroot}%{_sysconfdir}/logrotate.d/cgiwrap << EOF
/var/log/cgiwrap.log {
    monthly
    missingok
    nocompress
    prerotate
	%{_initrddir}/httpd closelogs > /dev/null 2>&1
    endscript
    postrotate
	%{_initrddir}/httpd closelogs > /dev/null 2>&1
    endscript
}
EOF

# cleanup
rm -f %{buildroot}/var/www/html/cgiwrap/*\~

%post
%create_ghostfile /var/log/cgiwrap.log apache root 0644

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README doc/*
%attr(0640,root,root) %config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/httpd/conf/webapps.d/*_cgiwrap.conf 
%attr(0644,root,root) %config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/logrotate.d/cgiwrap
%attr(0640,root,root) %config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/cgiwrap.*
%attr(4711,root,root) /var/www/cgi-bin/*
%attr(0644,root,root) /var/www/html/cgiwrap/*.html
%ghost %attr(0644,apache,root) /var/log/cgiwrap.log


%changelog
* Wed Sep 02 2009 Thierry Vignaud <tvignaud@mandriva.com> 4.1-2mdv2010.0
+ Revision: 424796
- rebuild

* Thu Aug 14 2008 Oden Eriksson <oeriksson@mandriva.com> 4.1-1mdv2009.0
+ Revision: 271985
- 4.1
- drop upstream implemented patch

* Sun Jul 20 2008 Oden Eriksson <oeriksson@mandriva.com> 3.9-5mdv2009.0
+ Revision: 238956
- rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Jun 24 2007 Oden Eriksson <oeriksson@mandriva.com> 3.9-4mdv2008.0
+ Revision: 43790
- fix deps


* Fri Mar 02 2007 Oden Eriksson <oeriksson@mandriva.com> 3.9-3mdv2007.0
+ Revision: 131177
- Import cgiwrap

* Fri Feb 03 2006 Oden Eriksson <oeriksson@mandriva.com> 3.9-3mdk
- add a missing percent character...

* Fri Feb 03 2006 Oden Eriksson <oeriksson@mandriva.com> 3.9-2mdk
- misc spec file fixes
- added P0 from the sf tracker

* Fri Jan 14 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 3.9-1mdk
- 3.9

* Wed Nov 24 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.8-3mdk
- nuke redundant provides

* Sat Oct 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.8-2mdk
- rpmbuildupdated

